\section{Operations on AWS}
The content of this section is from an official AWS course.

\subsection{Module 1 - Understanding System Operations}
The system operation in the cloud consists of: build, test, deploy, monitor, maintain, safeguard the system. The key services for systems operations are: networking, compute, access services.

The automation of system operations enables
\begin{itemize}
	\item Repeatable deployment of infrastructure and applications on demand
	\item Creation of self-describing systems
	\item Build well tested systems
\end{itemize}

\subsubsection{Scope of AWS Service}
\textbf{Region}
\begin{itemize}
	\item Amazon S3
	\item Amazon Machine Images
	\item Amazon CloudWatch metrics
	\item Amazon Elastic Block Storage
	\item Amazon ElastiCache Clusters
	\item Amazon Virtual Private Cloud
\end{itemize}

\textbf{Global}
\begin{itemize}
	\item IAM users, groups and roles
	\item Amazon Route 53 hosted zones and record sets
	\item Amazon CloudFront distributions
\end{itemize}

\textbf{Availability Zone}
\begin{itemize}
	\item Amazon EC2 instances
	\item Amazon EBS volumes
	\item Amazon Relational Database Service
	\item Subnets
\end{itemize}

\subsubsection{Service Limits}
There are service limits in AWS in order to keep potential excessive charges low and keep the AWS network healthy. There are soft and hard limits. The soft limits chan be changed by the AWS support team, when you contact them, on the other hand the hard limits cant be changed.

\subsubsection{Identity and Access Management}
Allows you to centrally manage authentication and access to AWS resource and is offered as a feature of AWS with no charge. There you are able to create users, groups and roles and apply policies to control the access to the resources.

An IAM user can assume an IAM role to temporary extend their permissions. A user can also switch roles to access resources as another account, this is called cross-account access. 

\paragraph{Authentication} There is programmatic access which provides access to API, AWS CLI, SDK and other development tools. Additional there is console access to administer AWS from the management console.

Every AWS account has an assigned root user and root account. This is the owner of the tenant and should not be used to administer the tenant.

\paragraph{Policies and Permissions}
There are different types of policies.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.7\textwidth]{permissions}
  \caption{AWS Permission Policies}
\end{figure}

\subsubsection{AWS CLI}
The AWS Command Line Interface (AWS CLI) is a command line tool that provides an interface for interacting with products and services from Amazon Web Services (AWS). In order to configure the AWS cli we need to type \lstinline|aws configure|

\subsection{Module 2 - Tooling and Automation}

\subsubsection{AWS Systems Manager}
Is used to manage the systems running on the AWS cloud. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{systemsmanager}
  \caption{AWS Systems Manager}
\end{figure}

\paragraph{Automation} Safely automate common and repetitive IT operations and management tasks across AWS resources using automation documents.

\paragraph{SDKs} The concept of infrastructure as code is fundamental to cloud computing, and differentiates the cloud from more traditional IT environments. The AWS software development kits (SDKs) and the application programming interfaces (APIs) provide you the tools necessary for applications built on AWS to be managed as infrastructure as code.

\paragraph{AWS CloudFormation} AWS CloudFormation is another useful tool that enables a user to create, update, or delete entire AWS infrastructure deployments predictably and repeatedly. With AWS CloudFormation, an entire infrastructure can be modeled in a single text file written in JSONor YAML. The text file template can be used to define all the desired AWS resources for a stack.

Another feature of AWS CloudFormation is drift detection. Performing a drift detection operation on a stack determines whether the stack has drifted from its expected template configuration.If the resource in the stack supports drift detection, the drift detection operation returns detailed information about the drift status of that resource.

\paragraph{AWS OpsWorks} Is a configuration management service that provides managed instances of Chef and Puppet. Chef and Puppet are automation platforms that allow you to use code to automate the configurations of your servers.

\subsection{Module 3 - Computing Servers}
Amazon EC2 instances run as virtual machines on host computers that are located in AWS Availability Zones. Each virtual machine runs an operating system, such as Amazon Linux or Microsoft Windows.

Some EC2 instances use an instance store. The instance store, which is also known as ephemeral storage, is storage that is physically attached to the host computer and provides temporary block-level storage for use with an instance. The data in an instance store persists only during the lifetime of the instance that uses it. 

\begin{figure}[h!]
  \center
  \includegraphics[width=\textwidth]{ec2}
  \caption{AWS EC2 Instance}
\end{figure}

\paragraph{Instance Types}
Instance types refer to the available selection of instances that you can choose from for your workloads. There are many instance types. Some are general purpose, while others are designed to provide extra CPU (processing power), extra RAM (memory), or extra I/O Network performance.

\paragraph{Amazon Machine Image (AMI)}
An AMI provides the information that is required to launch an instance, which is a virtual server in the cloud. You must specify a source AMI when you launch an instance. You can launch multiple instances from a single AMI when you need multiple instances that have the same configuration. An AMI consists of: Template for instance volumes, Launch permissions, Block device mappings.

\paragraph{Networking} 
When you launch an EC2 instance, you launch it into a network environment, typically into typically into a virtual private cloud (VPC) that is created with Amazon Virtual Private Cloud (Amazon VPC).

Another part of the network configuration is an internet gateway.An internet gateway is a horizontally scaled, redundant, and highly available VPC component that allows communication between the instances that are in your VPC and the internet. 

\paragraph{IP Addresses}
When you create a new Amazon EC2 instance in a VPC, including your default VPC, you must think about whether users outside of your private network should access the instance. There are private, public (lost at stop of instance) and elastic (persistent) IP addresses. 

A connection between two or more virtual private clouds (VPCs)is known as a peering connection.

\paragraph{Security Groups}
Security groups are essentially stateful firewalls that surround one or more EC2 instances, allowing you to control the ICMP, TCP, and UDP-base network traffic that are allowed to pass to the instance. It’s important to understand that security groups are applied to specific instances rather than at the entry point to your network. You can assign multiple security groups to a single instance.

\paragraph{Instance Profile}
When you want to grant specific access rights for AWS account services to applications that run on an EC2 instance or users who are connected to an EC2 instance, you can assign an instance profile to the instance. An instance profile is a container for an IAM role. 

\paragraph{User Data} 
With user data, you can supply a script to a Linux or Windows instance. This script runs at instance launch as a series of commands during the end of the boot process. Scripts take the form of shell scripts on Linux instances, or batch or PowerShell scripts on Windows instances.

\paragraph{Metadata}
Metadata about a running instance is accessible from within an instance at runtime on \lstinline|192.254.169.254|. You can use this metadata to configure or manage the instance.


\subsection{Module 4 - Scaling}

\paragraph{Scaling on Demand}
In a traditional data center environment, the scalability of your system is bound by your hardware. In the cloud, because computing power is a programmatic resource, you can take a more flexible approach to the issue of scaling.

\subsubsection{Elastic Load Balancing (ELB)}
Elastic load balancing is a common characteristic of web application deployments. The Elastic Load Balancing (ELB) service routes client requests across multiple EC2 instances or Amazon Elastic Container Service (Amazon ECS) containers that are running your web application, and in this way, it balances the load. Using Cross-zone Load Balancing, the need to maintain multiple instances in one AZ can be reduced, as it is balanced over other AZs.

\textbf{Key Features}
\begin{itemize}
	\item High availability (HA) - ELB can distribute traffic across multiple targets.
	\item Health checks - ELB can detect unhealthy targets.
	\item Security - You can create and manage security groups that are associated with Load Balancers.
	\item TLS - Central certificate management and the applications don't have to manage the TLS connection.
\end{itemize}

\paragraph{Application Load Balancer (ALB)}
An Application Load Balancer (ALB) supports content-based routing, and supports applications that run in containers. Application Load Balancers also support the WebSocket and HTTP/2 industry-standard protocols, and provide additional visibility into the health of the target instances and containers.

\paragraph{Network Load Balancer (NLB)}
The Network Load Balancer (NLB) is designed to handle tens of millions of requests per second while maintaining high throughput at ultra low latency, with no effort on your part. Network Load Balancers route connections to targets,Amazon EC2 instances, containers, and IP addresses based on IP protocol data. A Network Load Balancer is ideal for load balancing TCP or UDP traffic, and it is optimized to handle sudden and volatile traffic patterns while using a single static IP address per Availability Zone.

\paragraph{Classic Load Balancer (CLB)}
The Classic Load Balancer (CLB) provides basic load balancing across multiple EC2 instances and operates at both the request level and connection level. Classic Load Balancers are intended for applications that were built within the EC2-Classic network.

\paragraph{Load Balancer: Listeners}
Before you start using your Application Load Balancer, you must add one or more listeners. A listeneris a process that checks for a connection request from a client to an instance by using the protocol and port that you specify.

\paragraph{Target Groups}
A load balancer serves as the single point of contact for clients. When you create each listener rule, you specify a target group and conditions. The load balancer can distribute incoming application traffic across multiple targets. 

\subsubsection{Application Load Balancer Components}
As you can see, the load balancer serves as the single point of contact for all clients. It distributes incoming application traffic across multiple targets.

An Application Load Balancer can have more than one listener. In this example, there are two listeners. The listener forwards requests to one or more target groups, based on the defined rules. Each rule specifies a target group, condition, and priority.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{alb}
  \caption{Application Load Balancer Example}
\end{figure}

\subsubsection{EC2 Auto Scaling}
Amazon EC2 Auto Scaling helps you maintain application availability and allows you to automatically add or remove EC2 instances according to conditions you define.  For example, you can configure EC2 Auto Scaling to terminate EC2 instances the fail health status checks, and launch new EC2 Instances to replace the terminated ones. You can create user-defined policies that use Amazon CloudWatch to trigger when to add or remove Amazon EC2 instances based on conditions such as average CPU utilization of your Amazon EC2 fleet.

To configure EC2 Auto Scaling, you must first create a launch configuration, and then create an Auto Scaling group. There are to basic ways to trigger an auto scaling group: Scaling policy based in CloudWatch, Scheduled action.

\paragraph{Launch Configuration} To create a launch configuration,you must specify AWS Identity and Access Management (IAM) roles, security groups, storage, instance type, user data, key pairs, etc. These requirements are similar to the requirements for launching an EC2 instance.

\paragraph{Termination Policy}
With each Auto Scaling group, you control when it adds instances (which is referred to as scaling out) or remove instances (which is referred to as scaling in) from your network architecture. The default termination policy is designed to help ensure that your instances span Availability Zones evenly for high availability. The default termination policy is typically sufficient for most situations. Use the EC2 Auto Scaling API TerminateInstanceInAutoScalingGroup action to atomically terminate a specific instance and, optionally, to decrement the desired group size. For example, you might choose to always terminate the instance with the fewest user sessions.

\paragraph{Ready-State Group}
EC2 Auto Scaling health checks enable you to create a steady-state group that ensures that a single instance is always running. This is useful for situations, such as when you have a network address translation (NAT) server, and you do not want it to be a single point of failure in a standard public/private subnet architecture.

\paragraph{Scheduled Scaling an EC2}
Scaling based on a schedule enables you to scale your application in response to predictable load changes. For example, you notice that every week, the traffic to your web application starts to increase on Wednesday, remains high on Thursday, and starts to decrease on Friday. In these situations, you can plan your scaling activities based on the predictable traffic patterns of your web application.

\paragraph{Dynamic Scaling} 
Automatic scaling can be configured to be dynamic. For example, you have a web application that currently runs on three instances, and you do not want the CPU utilization of the Auto Scaling group to exceed 70 percent for more than 2 minutes. You can configure your Auto Scaling group to scale automatically to meet this need. The policy type determines how the scaling action is performed.

Amazon EC2 Auto Scaling supports the following types of scaling policies:
\begin{description}
	\item [Target Tracking Scaling] Increase or decrease the current capacity of the group based on a target value for a specific metric. 
	\item [Step Scaling] Increase or decrease the current capacity of the group based on a set of scaling adjustments, which are known as step adjustments, that vary based on the size of the alarm breach.
	\item [Simple Scaling] Increase or decrease the current capacity of the group based on a single scaling adjustment.
\end{description}

\paragraph{Predictive Scaling}
Predictive scaling uses machine learning models to predict your expected traffic (and Amazon EC2 usage) — including daily and weekly patterns—by using data collected from your actual Amazon EC2 usage and data points that are drawn from our own observations. The model needs historical data from at least 1 day to start making predictions. The model is re-evaluated every 24 hours to create a forecast for the next 48 hours.

\subsection{Module 5 - Containers, Serverless Computing}
Serverless computing allows you to build and run applications and services without thinking about servers. Serverless applications do not require you to provision, scale, and manage any servers.

\subsubsection{AWS Lambda}
AWS provides serverless computing through the service called AWS Lambda. You can create Lambda functions for nearly any type of application or backend service, and everything required to run and scale your application with high availability is handled for you.

Run code for virtually any type of application or backend service. Upload your code, and Lambda takes care of everything that is required to run and scale your code with high availability.

With AWS Lambda, there are no new languages, tools, or frameworks to learn. You can use any third-party library, even native ones. AWS Lambda includes support for Java, Node.js, C\#, Python, and Ruby.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{lamda}
  \caption{AWS Lambda}
\end{figure}

\paragraph{Process of Developing and Deploying AWS Lambda}
\begin{enumerate}
	\item Define a Lambda handler class in your code. The handler allows you to specify where AWS Lambda can begin running your code.
	\item Create your AWS Lambda function. You can think of the function as the code you want to run. It includes your code, associated configuration information, and resource requirements.
	\item Configure access to resources with AWS Identity and Access Management (IAM) and IAM roles. You can use security groups and network access control lists (network ACLs) to provide your functions with access to your resources.
	\item Upload your code.
	\item Test the function, verify results, and review your logs.
	\item Monitor your Lambda functions and reports metrics through Amazon CloudWatch. Examples of what you can track include the number of requests, latency, and the number of requests that result in errors. 
\end{enumerate}

\paragraph{Lambda Layers}
You can configure your Lambda function to pull in additional code and content in the form of layers. A layer is a ZIP archive that contains libraries, a custom runtime, or other dependencies. With layers, you can use libraries in your function without needing to include them in your deployment package. A function can use up to five layers at a time. The total unzipped size of the function and all layers cannot exceed the unzipped deployment package size limit of 250 MB. For example, as of this writing, the maximum memory allocation for a single Lambda function is 3 GB. 

\subsubsection{API and REST}
Application programming interfaces (APIs) make computer software accessible to developers via code, so that they can build software programs that interact with other software programs or computer infrastructure. 

\subsubsection{RESTful APIs}
The six REST principles:
\begin{enumerate}
	\item There should be a simple and uniform interface for the client to access the server. A request should be made to a single endpoint or URI when interacting with each distinct resource that is part of the service. The interface does not define the structure of what is returned when the client makes a request.
	\item RESTful services are also stateless. Stateless means that the server does keep track of what requests the connecting client has made over time, or what step the client might have completed in terms of a series of actions. Instead, any session information about the client is only known to the client itself.
	\item he server doesn’t know about the state of the client, and the client doesn’t know about the state of the server. 
	\item REST clients should be able to cache the responses they receive from the REST server. 
	\item RESTful services support layered systems, where the client might connect to an intermediate server. This design enables the REST server to be distributed, which supports load balancing. 
	\item RESTful services can optionally support code on demand, which means that the server could pass a piece of code that can be run to the client (such as some JavaScript). This feature extends the functionality of the REST client. Uses for code-on-demand in RESTful APIs can achieve some of the 
\end{enumerate}

\subsubsection{Amazon API Gateway}
Amazon API Gateway is an AWS service that enables developers to create, publish, maintain, monitor, and secure APIs at any scale. You can create APIs that access AWS or other web services, as well as data stored in the AWS Cloud.

In Amazon API Gateway, the frontend is encapsulated by method requests and method responses.The backend is encapsulated by requests and responses that integrate with the other AWS services. These AWS services provide the functionality thatis exposed by the API, and take action accordingly.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{apigateway}
  \caption{AWS API Gateway}
\end{figure}

\subsubsection{Containers on AWS}
Containers deliver environmental consistency because the application’s code, configurations, and dependencies are packaged into a single object. 

Amazon Elastic Container Service (Amazon ECS) is a highly scalable, high performance container management service that supports Docker containers.



